<?php
/*
  =====================================================
  Module for Joomla - by SmsCoin
  -----------------------------------------------------
  http://smscoin.com
  -----------------------------------------------------
  Copyright (c) 2011 SmsCoin
  =====================================================
  File: result.php
  -----------------------------------------------------
  SMS payment module
  =====================================================
 */

define('_JEXEC', 1);
define('JPATH_BASE', dirname(__FILE__).'/../../../');
define('DS', DIRECTORY_SEPARATOR);

require_once(JPATH_BASE .DS.'includes'.DS.'defines.php');
require_once(JPATH_BASE .DS.'includes'.DS.'framework.php');

$mainframe = &JFactory::getApplication('site');
$mainframe->initialise();

$plugin = &JPluginHelper::getPlugin('content', 'smscoin_rkey');

/**
 * Функция возвращает MD5 переданных ей параметров
 * @return MD5 sign...
 */
function ref_sign() {
    $param = func_get_args();
    $prehash = implode("::", $param);
return md5($prehash);
}

/**
 * Парсим полученные параметры на предмет мусора
 */
foreach($_GET AS $k => $v) {
    $_GET[$k] = substr(trim(strip_tags($v)), 0, 250);
}

/**
 * Секретный код сервиса...
 */
$params = json_decode($plugin->params);

/**
 * MD5 хеш GET параметров
 */
$reference = ref_sign($params->secret_code,
        $_GET["key"],
        $_GET["pair"],
        $_GET["timeout"],
        $_GET["limit"],
        $_GET["content"],
        $_GET["country"],
        $_GET["cost_local"],
        $_GET["provider"]
        );

/**
 * Если подпись верна
 */
if($_GET["sign_v4"] == $reference) {

   /**
    * Запись данных в базу
    */
    $dbo = JFactory::getDbo();

    $query = $dbo->getQuery(true);
    $query->insert('#__skeys');
    $query->set('k_status = 1');
    $query->set('k_key = '. (int) $_GET["key"]);
    $query->set('k_pair = '. $dbo->Quote($_GET["pair"]));
    $query->set('k_country = '. $dbo->Quote($_GET["country"]));
    $query->set('k_provider = '. $dbo->Quote($_GET["provider"]));
    $query->set('k_text = '. $dbo->Quote($_GET["content"]));
    $query->set('k_cost_local = '. $dbo->Quote($_GET["cost_local"]));
    $query->set('k_created = '. time(true));
    $query->set('k_timeout = '. (int) $_GET["timeout"]);
    $query->set('k_limit_start = '. (int) $_GET["limit"]);
    $query->set('k_limit_current = '. (int) $_GET["limit"]);
    $dbo->setQuery($query);
    $dbo->query();

    echo 'OK';
} else {
    /**
     * Неправильно составлен запрос...
     */
    echo 'checksum failed';
}